#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef struct _autobusi{
	char naziv[41];
	int brautob;
	struct _autobusi *next;
}autobusi;

autobusi* kupnja(autobusi* first, char* naziv1, char* naziv2)
{
	autobusi *pom1, *pom2;

	//trazimo kompaniju naziv1
	for(pom1=first; pom1; pom1=pom1->next){
		if(!strcmp(pom1->naziv,naziv1)){
			break;
		}
	}
	//ukoliko je nisamo nasli, izlazimo iz funkcije
	if(!pom1)
		return first;

	//slucaj kad je kompanija naziv2 na prvom mjestu vezane liste
	if(!strcmp(first->naziv,naziv2)){
		pom1->brautob+=first->brautob;
		pom2=first;
		first=first->next;
		free(pom2);
		return first;
	}

	//slucaj kad je kompanija naziv2 iza prvog mjesta vezane liste
	for(pom2=first; pom2->next; pom2=pom2->next){
		if(!strcmp(pom2->next->naziv,naziv2)){
			break;
		}
	}
	if(!pom2->next)
		return first;
	pom1->brautob+=pom2->next->brautob;
	pom1=pom2->next;
	pom2->next=pom1->next;
	free(pom1);
	return first;
}

//pomocna funkcija (koristimo je u funkciji najbrojniji) koja vraca pokazivac na element (kompaniju) s najvise 
//autobusa
autobusi* max(autobusi* first)
{	
	if(!first)
		return first;

	autobusi* pommax=first, *pom;
	int brmax=first->brautob;

	for(pom=first; pom; pom=pom->next){
		if(pom->brautob>brmax){
			brmax=pom->brautob;
			pommax=pom;
		}
	}

	return pommax;
}

//pomocna funkcija (koristimo je u funkciji najbrojniji) koja vezanoj listi dodaje element novi tako da ostane
//sortirana uzlazno po broju autobusa kompanija)
void ubaci(autobusi** first, autobusi* novi)
{
	autobusi* pom=*first;	

	if(!*first || novi->brautob<(*first)->brautob){
		novi->next=*first;
		*first=novi;
	}
	else{
		while(pom->next && pom->next->brautob<novi->brautob)
			pom=pom->next;
		novi->next=pom->next;
		pom->next=novi;
	}
}

autobusi* najbrojniji(autobusi** first)
{
	autobusi* pom, *novi, *firstnovi=NULL;
	int n=0, br;
	
	//provjeravamo je li ulazna lista prazna	
	if(!*first)
		return *first;

	//odredjujemo broj kompanija
	for(pom=*first; pom; pom=pom->next)
		n++;

	//broj najboljih koje izdvajamo
	br=(n*0.05-(int)(n*0.05)==0)?(int)n*0.05:(int)n*0.05+1;

	while(br--){
		novi=max(*first);
		
		if(novi==*first)
			*first=(*first)->next;
		else{
			pom=*first;
			while(pom->next && pom->next!=novi)
				pom=pom->next;
			pom->next=novi->next;
		}
		ubaci(&firstnovi,novi);	
	}

	return firstnovi;
}

//za tesitranje nam treba ispis
void ispis(autobusi* first)
{
	while(first){
		printf("%s %d\n", first->naziv, first->brautob);
		first=first->next;
	}
	printf("\n");
}

int main(void)
{
	FILE *in;
	autobusi *first=NULL, *novi, *pom;
	char naziv[41];
	int brautob;

	if((in=fopen("autobusi.txt","rt"))==NULL){
		printf("Greska prilikom otvaranja datoteke!");
		exit(1);
	}
	
	while(fscanf(in,"%s %d", naziv, &brautob)>0){
		novi=(autobusi*)malloc(sizeof(autobusi));
		strcpy(novi->naziv,naziv);
		novi->brautob=brautob;
		
		if(!first)
			pom=first=novi;
		else{
			pom->next=novi;
			pom=pom->next;
		}
	}
	pom->next=NULL;
	
	ispis(first);
	
	//first=igra(first,"Ante","Jelena");
	//ispis(first);

	//first=igra(first,"Ante","Emanuel");
	//ispis(first);

	novi=najbrojniji(&first);
	ispis(first);
	ispis(novi);

	for(pom=first; pom; pom=first){
		pom=first;
		first=first->next;
		free(pom);
	}

	return 0;
}
